diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 57433468e..240f39051 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -3141,36 +3075,50 @@ public class World implements WorldSource {
         return savedDataStorage.getFreeMetadataFor(s);
     }
 
-    public void playBlockEvent(int id, int x, int y, int z, int data)
-    {
-        playBlockEvent(null, id, x, y, z, data);
+    public void playBlockEvent(final @NotNull TilePos tilePos, final int id, final int data) {
+        this.playBlockEvent(null, tilePos, id, data);
     }
 
-    public void playBlockEvent(@Nullable Player player, int id, int x, int y, int z, int data)
-    {
-        for (LevelListener listener : listeners) {
-            listener.levelEvent(player, id, x, y, z, data);
+    @Deprecated
+    public final void playBlockEvent(final int id, final int x, final int y, final int z, final int data) {
+        this.playBlockEvent(new TilePos(x, y, z), id, data);
+    }
+
+    public void playBlockEvent(final @Nullable Player player, final @NotNull TilePos tilePos, final int id, final int data) {
+        for (final @NotNull LevelListener listener : this.listeners) {
+            listener.levelEvent(player, id, tilePos.x, tilePos.y, tilePos.z, data);
         }
+    }
 
+    @Deprecated
+    public final void playBlockEvent(final @Nullable Player player, final int id, final int x, final int y, final int z, final int data) {
+        this.playBlockEvent(player, new TilePos(x, y, z), id, data);
     }
     
-    public WorldType getWorldType()
+    public @NotNull WorldType getWorldType()
     {
         return worldType;
     }
 
-    public EntityItem dropItem(int x, int y, int z, ItemStack itemStack) {
-        float f = 0.7F;
-        double x1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-        double y1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-        double z1 = (double) (rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-        EntityItem item = new EntityItem(this, (double) x + x1, (double) y + y1, (double) z + z1, itemStack);
+    public @NotNull EntityItem dropItem(final @NotNull TilePos tilePos, final @NotNull ItemStack itemStack) {
+        final float radius = 0.7f;
+        final double x = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
+        final double y = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
+        final double z = (this.rand.nextFloat() * radius) + (1.0F - radius) * 0.5D;
+
+        final @NotNull EntityItem item = new EntityItem(this, tilePos.x + x, tilePos.y + y, tilePos.z + z, itemStack);
         item.pickupDelay = 10;
-        entityJoinedWorld(item);
+        this.entityJoinedWorld(item);
         return item;
     }
+
+    @Deprecated
+    public final @NotNull EntityItem dropItem(final int x, final int y, final int z, final @NotNull ItemStack itemStack) {
+        return this.dropItem(new TilePos(x, y, z), itemStack);
+    }
+
     public void sendGlobalMessage(String message){
-        for (Player player: players){
+        for (Player player : players){
             player.sendMessage(message);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 1ebdfe1ef..67969e846 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -6,49 +6,141 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.season.SeasonManager;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public interface WorldSource
-{
+public interface WorldSource {
+    int getHeightBlocks();
 
-    int getBlockId(int x, int y, int z);
+    int getBlockId(final @NotNull TilePos tilePos);
 
-    @Nullable Block<?> getBlock(int x, int y, int z);
+    @Deprecated
+    default int getBlockId(final int x, final int y, final int z) {
+        return this.getBlockId(new TilePos(x, y, z));
+    }
+
+    @Nullable Block<?> getBlock(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default @Nullable Block<?> getBlock(final int x, final int y, final int z) {
+        return this.getBlock(new TilePos(x, y, z));
+    }
+
+    @Nullable TileEntity getTileEntity(final @NotNull TilePos tilePos);
 
-    TileEntity getTileEntity(int x, int y, int z);
+    @Deprecated
+    default @Nullable TileEntity getTileEntity(final int x, final int y, final int z) {
+        return this.getTileEntity(new TilePos(x, y, z));
+    }
 
-    default <T> @Nullable T getBlockLogic(final int x, final int y, final int z, final Class<T> logicClass) {
-        final Block<?> block = getBlock(x, y, z);
-        if (block == null) return null;
-        final BlockLogic logic = block.getLogic();
+    default <T> @Nullable T getBlockLogic(final @NotNull TilePos tilePos, final @NotNull Class<T> logicClass) {
+        final @Nullable Block<?> block = this.getBlock(tilePos);
+        if (block == null) {
+            return null;
+        }
+
+        final @NotNull BlockLogic logic = block.getLogic();
         if (logicClass.isAssignableFrom(logic.getClass())) {
             return logicClass.cast(logic);
         }
+
         return null;
     }
 
-    float getBrightness(int x, int y, int z, int blockLightValue);
-    
-    int getLightmapCoord(int x, int y, int z, int blockLightValue);
+    @Deprecated
+    default <T> @Nullable T getBlockLogic(final int x, final int y, final int z, final @NotNull Class<T> logicClass) {
+        return this.getBlockLogic(new TilePos(x, y, z), logicClass);
+    }
+
+    float getBrightness(final @NotNull TilePos tilePos, final int lightEmission);
+
+    @Deprecated
+    default float getBrightness(final int x, final int y, final int z, final int lightEmission) {
+        return this.getBrightness(new TilePos(x, y, z), lightEmission);
+    }
+
+    int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission);
+
+    @Deprecated
+    default int getLightmapCoord(final int x, final int y, final int z, final int lightEmission) {
+        return this.getLightmapCoord(new TilePos(x, y, z), lightEmission);
+    }
+
+    int getLightmapCoord(int skyLight, int blockLight);
+
+    float getLightBrightness(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default float getLightBrightness(final int x, final int y, final int z) {
+        return this.getLightBrightness(new TilePos(x, y, z));
+    }
+
+    int getBlockData(final @NotNull TilePos tilePos);
 
-    int getLightmapCoord(int skylight, int blocklight);
+    @Deprecated
+    default int getBlockMetadata(final int x, final int y, final int z) {
+        return this.getBlockData(new TilePos(x, y, z));
+    }
+
+    @NotNull Material getBlockMaterial(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default @NotNull Material getBlockMaterial(final int x, final int y, final int z) {
+        return this.getBlockMaterial(new TilePos(x, y, z));
+    }
 
-    float getLightBrightness(int x, int y, int z);
+    boolean isBlockOpaqueCube(final @NotNull TilePos tilePos);
 
-    int getBlockMetadata(int x, int y, int z);
+    @Deprecated
+    default boolean isBlockOpaqueCube(final int x, final int y, final int z) {
+        return this.isBlockOpaqueCube(new TilePos(x, y, z));
+    }
 
-    Material getBlockMaterial(int x, int y, int z);
+    boolean isBlockNormalCube(final @NotNull TilePos tilePos);
 
-    boolean isBlockOpaqueCube(int x, int y, int z);
+    @Deprecated
+    default boolean isBlockNormalCube(final int x, final int y, final int z) {
+        return this.isBlockNormalCube(new TilePos(x, y, z));
+    }
 
-    boolean isBlockNormalCube(int x, int y, int z);
-    double getBlockTemperature(int x, int z);
-    double getBlockHumidity(int x, int z);
-    SeasonManager getSeasonManager();
-    Biome getBlockBiome(int x, int y, int z);
-    
-    int getSavedLightValue(LightLayer layer, int x, int y, int z);
+    double getBlockTemperature(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default double getBlockTemperature(final int x, final int z) {
+        return this.getBlockTemperature(new TilePos(x, 0, z));
+    }
+
+    double getBlockHumidity(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default double getBlockHumidity(final int x, final int z) {
+        return this.getBlockHumidity(new TilePos(x, 0, z));
+    }
+
+    double getBlockVariety(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default double getBlockVariety(final int x, final int z) {
+        return this.getBlockVariety(new TilePos(x, 0, z));
+    }
+
+    @NotNull SeasonManager getSeasonManager();
+
+    @NotNull Biome getBlockBiome(final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default @Nullable Biome getBlockBiome(final int x, final int y, final int z) {
+        return this.getBlockBiome(new TilePos(x, y, z));
+    }
+
+    int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos);
+
+    @Deprecated
+    default int getSavedLightValue(final @NotNull LightLayer layer, final int x, final int y, final int z) {
+        return this.getSavedLightValue(layer, new TilePos(x, y, z));
+    }
 
     boolean isRetro();
 }
